-- WORK 4-3-1
-- e[u쐬
CREATE TABLE raster43 AS
SELECT text 'http://tile.openstreetmap.org/18/232972/103027.png' AS upperleft_url,
	2 AS xtiles,	-- ̃^C
	2 AS ytiles,	-- c̃^C
	ST_Union(rast) AS rast
FROM raster42 ;

-- e[umF
SELECT upperleft_url, xtiles, ytiles, (ST_Metadata(rast)).* FROM raster43 ;

-- SQL 4-3-2
-- Ƃ肠X^̎ľoܓx
WITH a AS (
	-- URLɁAK\֐păY[xAX^ԍAcX^ԍ𒊏oAlɕϊ
	SELECT regexp_matches(upperleft_url, '/(\d+)/(\d+)/(\d+)\.png$') :: int[] AS reg, 
		xtiles, ytiles
	FROM raster43
), b AS (
	-- OubNŎgK\֐regexp_matchešʂzȂ̂ŁA1vfɕ
	-- Ƀ^Cԍ + c̃^CŉEɗאڂ^CԍZoAsƂĉ
	SELECT text 'upperleft' AS lab, reg[1] AS zoom, reg[2] AS xtile, reg[3] AS ytile
	FROM a
	UNION ALL SELECT 'lowerright', reg[1], reg[2] + xtiles, reg[3] + ytiles
	FROM a
), c AS (
	-- gl̏i1j
	SELECT *, 2 ^ zoom AS n FROM b
), d AS (
	-- ^C[XWZoBɕgl̏i2j
	SELECT *, xtile / n * 360 - 180 AS lon, pi() * (1 - 2 * ytile / n) AS ytmp
	FROM c
)
SELECT lab, zoom, xtile, ytile, lon,
	degrees(atan((exp(ytmp) - exp(-ytmp)) / 2)) AS lat -- ^C[YWZo
FROM d ;

-- SQL 4-3-3
WITH a AS (
	SELECT regexp_matches(upperleft_url, '/(\d+)/(\d+)/(\d+)\.png$') :: int[] AS reg, 
		xtiles, ytiles
	FROM raster43
), b AS (
	SELECT text 'upperleft' AS lab, reg[1] AS zoom, reg[2] AS xtile, reg[3] AS ytile
	FROM a
	UNION ALL SELECT 'lowerright', reg[1], reg[2] + xtiles, reg[3] + ytiles
	FROM a
), c AS (
	SELECT *, 2 ^ zoom AS n FROM b
), d AS (
	SELECT *, xtile / n * 360 - 180 AS lon, pi() * (1 - 2 * ytile / n) AS ytmp
	FROM c
	-- ܂SQL4-3-2Ɠ
), e AS (
	SELECT lab, zoom, xtile, ytile, lon,
		degrees(atan((exp(ytmp) - exp(-ytmp)) / 2)) AS lat
	FROM d
	-- ꂪSQL4-3-2ŋ߂
), f AS (
	-- [̌oܓxƁAX^̍W̏cTCYBc̓}CiX
	SELECT min(lon) AS upperleftx, max(lat) AS upperlefty,
		(max(lon) - min(lon)) AS lon_width, (min(lat) - max(lat)) AS lat_height
	FROM e
)
UPDATE raster43 AS x
SET rast = ST_SetUpperLeft(
		ST_SetScale(
			x.rast, f.lon_width / ST_Width(x.rast), f.lat_height / ST_Height(x.rast)
		), f.upperleftx, f.upperlefty)
FROM f ;

-- sʂ̊mF
SELECT (ST_MetaData(rast)).* FROM raster43 ;
