-- WORK 4-2-4 ̃NG
SELECT (ST_MetaData(rast)).* FROM raster42 ;

-- SQL4-2-51
SELECT filename,
	substring(filename, '^\d+_(\d+)') AS xtile, substring(filename, '_(\d+)_full') AS ytile
FROM raster42 ;

-- SQL 4-2-52
WITH a AS (
	SELECT filename,
		substring(filename, '^\d+_(\d+)') :: int AS xtile,
		substring(filename, '_(\d+)_full') :: int AS ytile
	FROM raster42
), b AS (
	SELECT min(xtile) xmin,  min(ytile) ymin FROM a
)
SELECT filename, xtile - xmin AS xloc, ytile - ymin AS yloc
FROM a, b ;

-- SQL 4-2-53
WITH a AS (
	SELECT filename,
		substring(filename, '^\d+_(\d+)') :: int xtile,
		substring(filename, '_(\d+)_full') :: int ytile
	FROM raster42
), b AS (
	SELECT min(xtile) xmin,  min(ytile) ymin FROM a
), c AS (
	SELECT filename, (xtile - xmin) * 256 xloc, (ytile - ymin) * -256 yloc
	FROM a, b
	-- ܂łAeX^filenameяC͂ upperleftx , upperlefty̏
)
UPDATE raster42 x
SET rast = ST_SetUpperLeft(rast, c.xloc, c.yloc)
FROM c WHERE x.filename = c.filename ;
	-- X^e[uƁAcubNfilenameŌAXV

-- SQL 4-2-6
COPY (
	WITH d AS (
		-- ^C1ɓAPNGɕϊBȊO͑OƊ{Iɓ
		SELECT ST_AsPNG(ST_Union(rast)) AS png FROM raster42
	)
	SELECT '<img src="data:image/png;base64,' ||
		replace(encode(png, 'base64'), E'\n', '') || '" />'
	FROM d
)
TO 'C:/Program Files/PostgreSQL/9.3/data/part42_check.htm' ;
-- o̓t@C͐΃pXŁAPostgreSQLCXg[ɐݒ肵f[^tH_ɂ܂
