# WORK 7-1
install.packages(
	c('RPostgreSQL', 'base64', 'png', 'rgeos', 'maptools'))

# WORK 7-2
library(RPostgreSQL)		# قǂ̃CXg[ƈႢA[h̓NH[e[Vł
con = dbConnect(PostgreSQL(),
	host='localhost', port=5432, dbname='handson2014', user="postgres",
	password='******')	# f[^x[Xւ̐ڑmBp[^͓KXɍ킹ĉ
dbGetQuery(con, 'SELECT postgis_full_version()')	# PostGIS̃o[W𓾂eXg

# WORK 7-3
library(base64)		# pbP[Wǂݍ
library(png)
b64 = 'C:/Program Files/PostgreSQL/9.3/data/part73_tmp.base64'	# ꎞt@CAtpX
png = 'tmp.png'		# PNG̈ꎞt@CA͑΃pXł
sql = paste(sep='', "COPY (
		SELECT replace(encode(ST_AsPNG(rast), 'base64'), E'\n', '') FROM raster43
	) TO '", b64, "'")	# SQLAꎞt@CpXɍ킹ēIɐ
dbSendQuery(con, sql)		# SQLsABase64t@Cꂽ͂
decode(b64, png)		# Base64  PNG ɕ
img = readPNG(png)		# PNGǂݍ
class(img)			# ʊmF
str(img)			# @V
file.remove(c(b64, png))

# WORK 7-4
library(rgeos)		# pbP[Wǂݍ
library(maptools)
sql = 'SELECT ST_AsText(ST_Envelope(rast)) FROM raster43'
wkt = dbGetQuery(con, sql)	# SQLsAŃX^OsWKT`RɎ荞߂͂
shp = readWKT(wkt)	# WKTRł̃WIgił̓|Sjɕϊ
bbx = bbox(shp)	# |SlW擾
print(bbx)		# ʊmF

# WORK 7-5
plot(type='n', x=bbx[1,], y=bbx[2,], xlab='longitude', ylab='latitude') # gvbg
rasterImage(img, xleft=bbx[1,1], ybottom=bbx[2,1],
	xright=bbx[1,2], ytop=bbx[2,2], interpolate=F) # interpolate I͕ԂAڂ₯

# WORK 7-6
sql = 'WITH a AS (
		SELECT ST_SetSrid(ST_Point(139.939, 35.902), 4326) AS geom
	)
	SELECT ST_AsText(geom), ST_AsText(ST_Buffer(geom :: geography, 100) :: geometry)
	FROM a'
wkt = dbGetQuery(con, sql)	# SQLs
poi = readWKT(wkt[1,1])	# ځi_jWIgɕϊ
buf = readWKT(wkt[1,2])	# ځiobt@jWIgɕϊ
plot(add=T, x=poi, cex=2, pch=15, col='red')	# dˍ킹add=Tw肷邾
plot(add=T, x=buf, lty=2)

# WORK 7-7
library(RPostgreSQL)	# pbP[Wǂݍ
library(base64)		
library(png)
library(rgeos)
library(maptools)
con = dbConnect(PostgreSQL(),
	host='localhost', port=5432, dbname='handson2014', user="postgres",
	password='******')	# f[^x[Xւ̐ڑmBp[^͓KXɍ킹ĉ
b64 = 'C:/Program Files/PostgreSQL/9.3/data/part73_tmp.base64'	# ꎞt@CAtpX
png = 'tmp.png'		# PNG̈ꎞt@CA͑΃pXł
sql = paste(sep='', "COPY (
		WITH a AS (
			SELECT ST_SetSrid(ST_Point(139.939, 35.902), 4326) AS geom
		), b AS (
			SELECT ST_Buffer(geom :: geography, 100) :: geometry AS geom
			FROM a
		)
		SELECT replace(encode(ST_AsPNG(ST_Clip(rast, geom)), 'base64'), E'\n', '')
		FROM b, raster43
	) TO '", b64, "'")	# SQLAꎞt@CpXɍ킹ēIɐ
dbSendQuery(con, sql)		# SQLsABase64t@Cꂽ͂
decode(b64, png)		# Base64  PNG ɕ
img = readPNG(png)		# PNGǂݍ
file.remove(c(b64, png))	# ꎞt@C폜
sql = 'WITH a AS (
		SELECT ST_SetSrid(ST_Point(139.939, 35.902), 4326) AS geom
	)
	SELECT ST_AsText(geom),
		ST_AsText(ST_Intersection(ST_Buffer(geom :: geography, 100) :: geometry,
			ST_Envelope(rast)))
	FROM a, raster43'
wkt = dbGetQuery(con, sql)	# SQLs
poi = readWKT(wkt[1,1])	# ځi_jWIgɕϊ
buf = readWKT(wkt[1,2])	# ځiobt@jWIgɕϊ
bbx = bbox(buf)		# |SlW擾
par(bg='lightblue')
plot(type='n', x=bbx[1,], y=bbx[2,], xlab='longitude', ylab='latitude') # gvbg
rasterImage(img, xleft=bbx[1,1], ybottom=bbx[2,1],
	xright=bbx[1,2], ytop=bbx[2,2], interpolate=F)	# win}ƂăX^`
plot(add=T, x=poi, cex=2, pch=15, col='red')		# dˍ킹add=Tw肷邾
plot(add=T, x=buf, lty=2)
dbDisconnect(con)	# ŌɃf[^x[Xؒf
